--[[
WarlockReminder Continued v1.40
26 Apr 2011
Author: CKlausi/Biny of Anetheron EU
Original Author of WarlockReminder: Vux of Dragonblight-US
Description: Helpful reminders for Warlocks
File: WarlockReminderFrame.lua
]]--

local WarlockReminder = LibStub("AceAddon-3.0"):GetAddon("WarlockReminder")
local L = LibStub("AceLocale-3.0"):GetLocale("WarlockReminder")
local media = LibStub("LibSharedMedia-3.0")
local textures = media:List("statusbar")
local fonts = media:List("font")

local diWidth = 132
local diHeight = 36

function WarlockReminder:CreateFrames()
	-- Set up anchor
	wlranchor = CreateFrame("Frame", nil, UIParent), {}
	wlranchor:SetWidth(120)
	wlranchor:SetHeight(24)
	wlranchor:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 8, edgeSize = 12, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	wlranchor:SetBackdropColor(0.1,0.1,0.2,1)
	wlranchor:SetBackdropBorderColor(0.1,0.1,0.1,1)
	wlranchor:SetMovable(1)
	wlranchor:EnableMouse(1)
	wlranchor:SetToplevel(1)
	wlranchor:SetClampedToScreen(1)
	wlranchor:SetPoint("CENTER")
	wlranchor:Hide()

	wlranchor.text = wlranchor:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	wlranchor.text:SetText("wlranchor")
	wlranchor.text:SetPoint("LEFT",6,0)

	wlranchor.close = CreateFrame("Button",nil,wlranchor,"UIPanelCloseButton")
	wlranchor.close:SetWidth(24)
	wlranchor.close:SetHeight(24)
	wlranchor.close:SetPoint("RIGHT")
	-- END Set up anchor

	-- Set up frame
	wlrframe = CreateFrame("Frame", nil, UIParent), {}
	wlrtexture = wlrframe:CreateTexture()
	wlrframe:SetAlpha(1)
	wlrframe:SetPoint("CENTER",wlranchor,0,-42)
	wlrframe:SetWidth(48)
	wlrframe:SetHeight(48)
	wlrtexture:SetAllPoints(wlrframe)
	wlrframe.text = wlrframe:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	wlrframe.text:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
	wlrframe:Hide()
	-- END Set up frame

	-- Set up diFrame
	diFrame = CreateFrame("Button", nil, UIParent, "SecureActionButtonTemplate"), {}
	diFrame:RegisterForClicks("LeftButtonDown")
	diFrame:SetAttribute("type", "spell")
	diFrame:SetAttribute("unit", "target")
	diFrame:SetAttribute("spell", DarkIntentSpell)

	diFrame:SetAlpha(1)
	diFrame:SetPoint("CENTER", UIParent, 0, 40)
	diFrame:SetWidth(diWidth)
	diFrame:SetHeight(diHeight)

	diFrame:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 8, edgeSize = 12, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	diFrame:SetBackdropColor(0.1,0.1,0.2,1)
	diFrame:SetBackdropBorderColor(0.1,0.1,0.1,1)
	diFrame:SetMovable(1)
	--diFrame:EnableMouse(1)
	diFrame:SetToplevel(1)
	diFrame:SetClampedToScreen(1)

	--Set up diTextureFrame
	diTextureFrame = CreateFrame("Frame", nil, diFrame), {}
	diTextureFrame:SetAlpha(0.75)
	diTextureFrame:SetPoint("LEFT", diFrame, 2, 0)
	diTextureFrame:SetWidth(32)
	diTextureFrame:SetHeight(32)
	diTexture = diTextureFrame:CreateTexture()
	diTexture:SetTexture(GetSpellTexture(DarkIntent))
	diTexture:SetAllPoints(diTextureFrame)
	diTextureFrame:Show()

	-- Set up diFontFrame
	diFontFrame = CreateFrame("Frame", nil, diFrame), {}
	diFontFrame:SetAlpha(0.75)
	diFontFrame:SetPoint("LEFT", diFrame, diTextureFrame:GetWidth(), 0)
	diFontFrame:SetWidth(diWidth-32)
	diFontFrame:SetHeight(diHeight -4)

	diFontFrame.text = diFontFrame:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	diFontFrame.text:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE")
	diFontFrame.text:SetText(L["No Dark Intent"])
	diFontFrame.text:SetPoint("LEFT",5,6)

	diFontFrame.textTime = diFontFrame:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	diFontFrame.textTime:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE")
	diFontFrame.textTime:SetText("")
	diFontFrame.textTime:SetPoint("LEFT",5,-6)

	diFrame:Hide()
	
	diFrame:SetScript("OnUpdate", function(self)
		WarlockReminder:OnUpdate()
	end )
	--END Set up diFrame
	
	-- Set up isfBar
	isfBar = CreateFrame("StatusBar", nil, UIParent), {}
	isfBar:SetMovable(1)
	isfBar:SetToplevel(1)
	isfBar:SetAlpha(0.75)
	isfBar:SetWidth(160)
	isfBar:SetHeight(20)
	isfBar:SetClampedToScreen(1)
	isfBar:SetOrientation("HORIZONTAL")
	isfBar:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16})
	isfBar:SetStatusBarTexture(media:Fetch("statusbar","Blizzard"))
	isfBar:SetPoint("CENTER", UIParent, 0, 40)
	isfBar:SetStatusBarColor(170/255, 10/255, 10/255)
	isfBar:SetMinMaxValues(0, 15)
	--isfBar:SetValue(10)
	isfBar:Hide()
	
	-- isfText
	isfBar.text = isfBar:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	isfBar.text:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
	isfBar.text:SetText(isfBar:GetValue())
	isfBar.text:SetPoint("RIGHT",0,0)
	
	-- isfIcon
	isfIcon = CreateFrame("Frame", nil, isfBar), {}
	isfIcon:SetAlpha(0.75)
	isfIcon:SetPoint("LEFT", isfBar, -1*(isfBar:GetHeight()), 0)
	isfIcon:SetWidth(isfBar:GetHeight())
	isfIcon:SetHeight(isfBar:GetHeight())
	isfIconTexture = isfIcon:CreateTexture()
	isfIconTexture:SetTexture(GetSpellTexture(Isf))
	isfIconTexture:SetAllPoints(isfIcon)
	isfIcon:Show()
	
	isfBar:SetScript("OnUpdate", function(self)
		WarlockReminder:OnUpdate()
	end )
	--END Set up isfBar
	
	-- Move anchor
	wlranchor:SetScript("OnMouseDown",wlranchor.StartMoving)
	wlranchor:SetScript("OnMouseUp",
		function(self) 
			self:StopMovingOrSizing() 
			-- Set anchor
			WarlockReminder:SetWlrAnchorLeft("Anchor", self:GetLeft()) 
			WarlockReminder:SetWlrAnchorTop("Anchor", self:GetTop()) 
			WarlockReminder:FramesToAnchor()
		end
	)
	wlranchor:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	-- END Move anchor

	-- Move Dark Intent
	diFrame:SetScript("OnMouseDown", 
		function(self)
			if self:IsMovable() == 1 then
				self:StartMoving()
			end
		end
	)
	diFrame:SetScript("OnMouseUp",
		function(self) 
			if self:IsMovable() == 1 then
				self:StopMovingOrSizing() 
				-- Set diFrame
				WarlockReminder:SetDiFrameLeft("diFrame", self:GetLeft()) 
				WarlockReminder:SetDiFrameTop("diFrame", self:GetTop()) 
			end
		end
	)
	diFrame:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	-- END Move Dark Intent
	
	-- Move Isf
	isfBar:SetScript("OnMouseDown", 
		function(self)
			if self:IsMovable() == 1 then
				self:StartMoving()
			end
		end
	)
	isfBar:SetScript("OnMouseUp",
		function(self) 
			if self:IsMovable() == 1 then
				self:StopMovingOrSizing() 
				-- Set diFrame
				WarlockReminder:SetIsfLeft("isfBar", self:GetLeft()) 
				WarlockReminder:SetIsfTop("isfBar", self:GetTop()) 
			end
		end
	)
	isfBar:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	-- END Move Isf
	
	-- Set up customanchor
	wlrcustomanchor = CreateFrame("Frame", nil, UIParent), {}
	wlrcustomanchor:SetWidth(120)
	wlrcustomanchor:SetHeight(24)
	wlrcustomanchor:SetBackdrop({ bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 8, edgeSize = 12, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	wlrcustomanchor:SetBackdropColor(0.1,0.1,0.2,1)
	wlrcustomanchor:SetBackdropBorderColor(0.1,0.1,0.1,1)
	wlrcustomanchor:SetMovable(1)
	wlrcustomanchor:EnableMouse(1)
	wlrcustomanchor:SetToplevel(1)
	wlrcustomanchor:SetClampedToScreen(1)
	wlrcustomanchor:SetPoint("CENTER")
	wlrcustomanchor:Hide()

	wlrcustomanchor.text = wlrcustomanchor:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	wlrcustomanchor.text:SetText("wlrcustomanchor")
	wlrcustomanchor.text:SetPoint("LEFT",6,0)

	wlrcustomanchor.close = CreateFrame("Button",nil,wlrcustomanchor,"UIPanelCloseButton")
	wlrcustomanchor.close:SetWidth(24)
	wlrcustomanchor.close:SetHeight(24)
	wlrcustomanchor.close:SetPoint("RIGHT")
	-- END Set up customanchor
	
	-- Set up customframe
	wlrcustomframe = CreateFrame("Frame", nil, UIParent), {}
	wlrcustomtexture = wlrcustomframe:CreateTexture()
	wlrcustomframe:SetAlpha(1)
	wlrcustomframe:SetPoint("CENTER",wlrcustomanchor,0,-42)
	wlrcustomframe:SetWidth(48)
	wlrcustomframe:SetHeight(48)
	wlrcustomtexture:SetAllPoints(wlrcustomframe)
	wlrcustomframe.text = wlrcustomframe:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	wlrcustomframe.text:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE")
	wlrcustomframe:Hide()
	-- END Set up customframe
	
	-- Move customanchor
	wlrcustomanchor:SetScript("OnMouseDown",wlrcustomanchor.StartMoving)
	wlrcustomanchor:SetScript("OnMouseUp",
		function(self) 
			self:StopMovingOrSizing() 
			-- Set anchor
			WarlockReminder:SetWlrCustomAnchorLeft("Anchor", self:GetLeft()) 
			WarlockReminder:SetWlrCustomAnchorTop("Anchor", self:GetTop()) 
			WarlockReminder:FramesToAnchor()
		end
	)
	wlrcustomanchor:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	-- END Move customanchor
end
-- END CreateFrames

-- Resets the anchor to the middle of the screen
function WarlockReminder:ResetAnchor()
	wlranchor:ClearAllPoints()
	wlranchor:SetPoint("CENTER",UIParent,"CENTER", 0, 0)
	self:SetWlrAnchorLeft("Anchor", wlranchor:GetLeft())
	self:SetWlrAnchorTop("Anchor", wlranchor:GetTop())
	WarlockReminder:FramesToAnchor()
	wlranchor:Show()
end

-- Resets the customanchor to the middle of the screen
function WarlockReminder:ResetCustomAnchor()
	wlrcustomanchor:ClearAllPoints()
	wlrcustomanchor:SetPoint("CENTER",UIParent,"CENTER", 0, 0)
	self:SetWlrCustomAnchorLeft("Anchor", wlrcustomanchor:GetLeft())
	self:SetWlrCustomAnchorTop("Anchor", wlrcustomanchor:GetTop())
	WarlockReminder:FramesToAnchor()
	wlrcustomanchor:Show()
end

-- Resets the diFrame to the middle of the screen
function WarlockReminder:ResetDiFrame()
	diFrame:ClearAllPoints()
	diFrame:SetPoint("CENTER",UIParent,"CENTER", 0, 40)
	self:SetDiFrameLeft("diFrame", diFrame:GetLeft())
	self:SetDiFrameTop("diFrame", diFrame:GetTop())
	diFrame:Show()
end

-- Resets the isfBar to the middle of the screen
function WarlockReminder:ResetIsfBar()
	isfBar:ClearAllPoints()
	isfBar:SetPoint("CENTER",UIParent,"CENTER", 0, -40)
	self:SetIsfLeft("isfBar", isfBar:GetLeft())
	self:SetIsfTop("isfBar", isfBar:GetTop())
	isfBar:Show()
end

function WarlockReminder:DiFrameSetFontGab()
	diFontFrame.text:SetPoint("LEFT",5,4+(0.2*diFontFrame.text:GetHeight()))
	diFontFrame.textTime:SetPoint("LEFT",5,-4-(0.2*diFontFrame.textTime:GetHeight()))
end

-- DiFrame Setup
function WarlockReminder:DiFrameSetup()
	diFrame:ClearAllPoints()
	-- Position
	diFrame:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT", self.db.profile.diFrameLeft, self.db.profile.diFrameTop)
	
	-- Alpha
	diFrame:SetAlpha(self.db.profile.diFrameAlpha)
	-- BG Alpha
	diFrame:SetBackdropColor(0.1,0.1,0.2,self.db.profile.diBgAlpha)
	diFrame:SetBackdropBorderColor(0.1,0.1,0.1,self.db.profile.diBgAlpha)
	
	-- Size
	diFrame:SetWidth((diWidth*self.db.profile.diFrameSize)+self.db.profile.diExtraWidth)
	diFrame:SetHeight(diHeight*self.db.profile.diFrameSize)
	diTextureFrame:SetWidth((diHeight-4)*self.db.profile.diFrameSize)
	diTextureFrame:SetHeight((diHeight-4)*self.db.profile.diFrameSize)
	diTexture:SetAllPoints(diTextureFrame)
	
	-- Font
	diFontFrame:SetWidth((diWidth-32)*self.db.profile.diFrameSize)
	diFontFrame:SetHeight((diHeight-4)*self.db.profile.diFrameSize)
	diFontFrame:SetPoint("LEFT", diFrame, diTextureFrame:GetWidth(), 0)
	diFontFrame.textTime:SetFont("Fonts\\FRIZQT__.TTF", self.db.profile.diFontSize, "OUTLINE")
	diFontFrame.text:SetFont("Fonts\\FRIZQT__.TTF", self.db.profile.diFontSize, "OUTLINE")
	self:DiFrameSetFontGab()
	
	-- Movable
	if(self.db.profile.diFrameLock == true) then 
		diFrame:SetMovable(0)
	else 
		diFrame:SetMovable(1) 
	end
	
	-- Show/Hide
	if(self.db.profile.showDarkIntentFrame) then diFrame:Show()
	else diFrame:Hide() end
end

-- CustomReminder Setup
function WarlockReminder:CustomSetup()
	wlrcustomanchor:ClearAllPoints()
	
	-- Position
	wlrcustomanchor:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT", self.db.profile.wlrCustomAnchorLeft, self.db.profile.wlrCustomAnchorTop)
	
	wlrcustomframe:SetAlpha(self.db.profile.wlrCustomAnchorAlpha)
	wlrcustomframe:SetWidth(48*self.db.profile.wlrCustomAnchorSize)
	wlrcustomframe:SetHeight(48*self.db.profile.wlrCustomAnchorSize)
	
	-- Alpha
	wlrcustomframe:SetAlpha(self.db.profile.wlrCustomAnchorAlpha)
	
	-- Size
	wlrcustomframe:SetWidth(48*self.db.profile.wlrCustomAnchorSize)
	wlrcustomframe:SetHeight(48*self.db.profile.wlrCustomAnchorSize)
	
	WarlockReminder:FramesToAnchor()
	
	-- Show/Hide
	if(self.db.profile.showCustom) then 
		wlrcustomframe:Show()
	else 
		wlrcustomframe:Hide() 
		wlrcustomanchor:Hide()
	end
end
-- End CustomReminder Setup

-- Isfbar setup
function WarlockReminder:IsfSetup()
	isfBar:ClearAllPoints()
	-- Position
	isfBar:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT", self.db.profile.isfLeft, self.db.profile.isfTop)
	
	-- Text position
	isfBar.text:ClearAllPoints()
	if (self.db.profile.isfTextPosition == 0) then isfBar.text:SetPoint("RIGHT",0,0)
	elseif (self.db.profile.isfTextPosition == 1) then isfBar.text:SetPoint("LEFT",0,0)
	else isfBar.text:SetPoint("CENTER",0,0) end
	
	-- Alpha
	isfBar:SetAlpha(self.db.profile.isfAlpha)
	
	-- Width & Height
	isfBar:SetWidth(self.db.profile.isfWidth)
	isfBar:SetHeight(self.db.profile.isfHeight)
	isfIcon:SetWidth(isfBar:GetHeight())
	isfIcon:SetHeight(isfBar:GetHeight())

	-- Movable
	if(self.db.profile.isfLock == true) then 
		isfBar:SetMovable(0)
	else 
		isfBar:SetMovable(1) 
	end
	
	-- Show/Hide
	if(self.db.profile.showIsf) and
		self.db.profile.isfInCombat == false
	then isfBar:Show()
	else isfBar:Hide() end
end

-- Attach all frames to the anchor
function WarlockReminder:FramesToAnchor()
	wlrframe:SetPoint("CENTER",wlranchor,0,-42)
	wlrcustomframe:SetPoint("CENTER",wlrcustomanchor,0,-42) 
end

-- Show the reminder frame
function WarlockReminder:WlrFrame(show, texture)
	if texture then wlrtexture:SetTexture(GetSpellTexture(texture))
	else wlrtexture:SetTexture(GetSpellTexture(DrainSoul)) end
	if show then 
		wlrframe.text:SetText("")
		wlrframe:Show()
	else 
		wlrframe:Hide()
	end
end

-- Show the customreminder frame
function WarlockReminder:WlrCustomFrame(show, texture, count)
	if texture then wlrcustomtexture:SetTexture(GetSpellTexture(texture))
	else wlrcustomtexture:SetTexture(GetSpellTexture(FelSpark)) end
	
	if not count or count == 0 then count = "" end
	
	if show then 
		wlrcustomframe.text:SetText(tostring(count))
		wlrcustomframe.text:SetPoint("BOTTOMRIGHT",-3,3)
		wlrcustomframe:Show()
	else 
		wlrcustomframe:Hide()
	end
end

-- Show the drain soul frame
function WarlockReminder:WlrDrainSoulFrame(show)
	if show then 
		wlrtexture:SetTexture(GetSpellTexture(DrainSoul))
		wlrframe.text:SetText("")
		wlrframe:Show()
		self:CancelTimer(self.drainsoultimer, true)
		if self:GetDrainSoulDuration("DrainSoulFrame") > 0 then
			self.drainsoultimer = self:ScheduleTimer("WlrDrainSoulFrame", self.db.profile.drainSoulDuration, false)
		end
	else 
		self:CancelTimer(self.drainsoultimer, true)
		wlrframe:Hide() 
	end
end

-- Show the Molten Core Frame
function WarlockReminder:WlrMoltenCoreFrame(show, count)
	if not count then count = 0 end
	if show then
		wlrtexture:SetTexture(GetSpellTexture(MoltenCore3))
		wlrframe.text:SetText(tostring(count))
		wlrframe.text:SetPoint("BOTTOMRIGHT",-3,3)
		wlrframe:Show()
	else
		wlrframe:Hide()
	end
end
